#include<cstdlib>
#include<stdio.h>
#include <string.h>
#include<unistd.h>
#include<fcntl.h>
#include<sys/ioctl.h>
#include<linux/fb.h>
#include<linux/fs.h>
#include<math.h>

#define NODETYPE_SLAVE	0
#define NODETYPE_MASTER	1
unsigned int	node_type = NODETYPE_SLAVE;

#include "ray.h"

#define DEVICE_NAME "/dev/fb0"

unsigned int	*ntime = (unsigned int *) MASTER_NTIME;

const static double Ignored_Err=0.00001;
unsigned short *fbptr;

typedef struct Vector3D {
	double x,y,z;
} Vector3D;

typedef struct RaySphare {
	Vector3D c;
	double r;
} RaySphare;

void DrawPixel(int x,int y, unsigned int R, unsigned int G, unsigned int B);

#define pixel_odd(c)	(c & 0x0f)
#define pixel_even(c)	(c & 0xf0) >> 4

int	already_checked = 0;
int	xMax = 0,
	yMax = 0;

int
isCalcCompleted ()
{
	unsigned int *xs = (unsigned int *)MASTER_LINES_NODE;

	for (int i = 1; i < 200; i++) {
		if (! xs[i]) {
			already_checked  ++;
			return False;
		}
	}

	return True;
}

void
ClearNodes ()
{
	unsigned int *nodes = (unsigned int *)MASTER_LINES_NODE;
	unsigned int *xs = (unsigned int *)MASTER_LINES_X;

	memset (nodes, 0, sizeof (unsigned int) * 200);
	memset (xs, 0, sizeof (unsigned int) * 200);
#if 0
	CommitChanges (nodes, sizeof (unsigned int)*200);
	CommitChanges (xs, sizeof (unsigned int)*200);
	CommitChanges ((void *) MASTER_LINES_X, 256);
#endif
	CommitChanges ((void *) MASTER_NTIME, 34404);

	return ;
}

void
DrawLine (int y, unsigned char *data, unsigned int nTime) {
	unsigned char	c;
	unsigned int	brightness;

	for (int x = 0; x < 320; x++) {
		if (x%2)
			brightness = pixel_even(data[x/2]);
		else
			brightness = pixel_odd(data[x/2]);

		brightness <<= 4;
		if (nTime%2)
			DrawPixel(x,y,brightness,brightness,brightness);
		else
			DrawPixel(x,y, brightness, brightness, 0);
	}
}

void
ray_main ()
{
	self_nodeid = * ((unsigned int *) MGT_SELFNODEID);
	unsigned char	*mp = (unsigned char *) MASTER_LINES_POINT;
	unsigned char	*lp = slave_retrieve_points(self_nodeid);
	unsigned int	*xs = (unsigned int *) MASTER_LINES_X;
	unsigned int	*nodes = (unsigned int *) MASTER_LINES_NODE;

	// ここから描画処理
	Vector3D v;v.x=160;v.y=100;v.z=-300; // 視点の位置ベクトル
	Vector3D p;p.x=0;p.y=0;p.z=0;		// 視線の方向ベクトル
	Vector3D s;s.x=0;s.y=0;s.z=0; // スクリーン上の描画対象点の位置ベクトル
	RaySphare ball;									 // 鏡面球体クラスインスタンス
	ball.c.x=160; ball.c.y=100; ball.c.z=50; ball.r=100;

	if (! is_master(self_nodeid))
		sleep (2);
	int i, j;
	if (is_master(self_nodeid)) {
		already_checked = 0;
	}

	slave_retrieve_line_y(self_nodeid) = 0;
	slave_retrieve_lines_x(self_nodeid) = 0;

	if (! is_master(self_nodeid))
		CommitChanges(slave_refer_to_lines_x(self_nodeid), 512);
calc_start:
	for(j=0;j<200;j++) {
		if (is_master (self_nodeid)) {
			MasterCheckLinesNode (j);
			MasterCheckLinesDone (j);
			CommitChanges ((void *) MASTER_NTIME, 34404);

			for (i = 0; i < 200; i++) {
				if (xs[i])
					DrawLine (i, (mp+(i*160)), *ntime);
				else if (*ntime)
					DrawLine (i, (mp+(i*160)), *ntime-1);
			}
		}
line_top:
		if (xs[j] == 320)
			continue;

		if (nodes[j] && (nodes[j] != self_nodeid)) {
			continue;
		}
		printf ("\x1b[6;43H");
		printf ("processing y=%03d\n", j);
		// if the result before not reflected
		int	y;
		if (! is_master (self_nodeid) &&
		   (y = slave_retrieve_line_y (self_nodeid)) && 
			slave_retrieve_lines_x (self_nodeid) == 320 &&
			xs[y] != 320 && nodes[y] == self_nodeid && j < 198) {
			CommitChanges(slave_refer_to_lines_x(self_nodeid), 512);
			goto line_top;
		}

		memset (lp, 0, 160);
		slave_retrieve_lines_x(self_nodeid) = 0;
		slave_retrieve_line_y (self_nodeid) = j;

		if (! is_master (self_nodeid))
			CommitChanges(slave_refer_to_lines_x(self_nodeid), 512);

		for(i=0;i<320;i++) {
			double plength;
			double a;

			if (is_master (self_nodeid)) {
				MasterCheckLinesNode (j);
				MasterCheckLinesDone (j);
				CommitChanges ((void *) MASTER_NTIME, 34404);
			} else
				CommitChanges(slave_refer_to_lines_x(self_nodeid), 512);

			if (nodes[j] && (nodes[j] != self_nodeid)) {
				break;
			}

			// p=s-v;
			s.x=i;s.y=j;s.z=0;
			p.x=s.x-v.x;
			p.y=s.y-v.y;
			p.z=s.z-v.z;

			// pを単位ベクトルに変換
			plength= sqrt(p.x*p.x+p.y*p.y+p.z*p.z);
			p.x/=plength;
			p.y/=plength;
			p.z/=plength;

			// vから出発するvd方向の視線がsにぶつかるか
			Vector3D e;
			double b,c,D;

			e.x=ball.c.x-v.x;
			e.y=ball.c.y-v.y;
			e.z=ball.c.z-v.z;

			b=-(p.x*e.x+p.y*e.y+p.z*e.z);
			c=e.x*e.x+e.y*e.y+e.z*e.z-ball.r*ball.r;

			// 判別式
			D=b*b-c;

			if(D>Ignored_Err){
				if(-b>sqrt(D)){
					// 二次方程式の解１
					a=(-b-sqrt(D));
				} else {
					// 二次方程式の解２
					a=(-b+sqrt(D));
				}

				if(a<0){
				// a<0なら 球と視線は、視点の背後で交差している
				// 球が見えない印にaを０にセット
					a=0;
				}
			} else {
		// 球と視線は交差していない。球が見えない印にaを０にセット
				a=0;
			}

			//球が見えるなら
			if(a>Ignored_Err){
				Vector3D m,r;
				// m=v+a*p;
				m.x=v.x+a*p.x;
				m.y=v.y+a*p.y;
				m.z=v.z+a*p.z;
	
				// 法線ベクトルを求める n=hit-this->c;
				Vector3D n;
				n.x=m.x-ball.c.x;
				n.y=m.y-ball.c.y;
				n.z=m.z-ball.c.z;

				double np=n.x*p.x+n.y*p.y+n.z*p.z;

				r.x= p.x + 2*(-np*n.x)/(n.x*n.x+n.y*n.y+n.z*n.z);
				r.y= p.y + 2*(-np*n.y)/(n.x*n.x+n.y*n.y+n.z*n.z);
				r.z= p.z + 2*(-np*n.z)/(n.x*n.x+n.y*n.y+n.z*n.z);

				// 反射方向ベクトルを視線ベクトルに反映
				p=r;
			}

			// 明るさ= p*l/|p|/|l|
			Vector3D l; // 光の方向ベクトル
			int brightness;

			l.x=l.y=l.z=1;
			brightness=(int)(255*(p.x*l.x+p.y*l.y+p.z*l.z)/
			(sqrt(p.x*p.x+p.y*p.y+p.z*p.z)*sqrt(l.x*l.x+l.y*l.y+l.z*l.z)));

			brightness >>= 4;
			//もしもbrightnessが負なら、視線は光と逆向き
			if(brightness<0){
				brightness=0;
			}

			if (i%2)
				lp[i/2] |= brightness;
			else
				lp[i/2] |= (brightness << 4);

		}
		if (i != 320)	// Done by another node
			continue;

		slave_retrieve_lines_x (self_nodeid) = 320;
		if (! is_master (self_nodeid)) 
			CommitChanges(slave_refer_to_lines_x(self_nodeid), 512);
		else
			CommitChanges ((void *) MASTER_NTIME, 34404);
#if 0
			CommitChanges ((void *) MASTER_LINES_X, 256);
#endif

#if 0
		if (is_master(self_nodeid)) {
			DrawLine (j, lp);
		}
#endif
	}
	if (! already_checked  && ! isCalcCompleted ()) {
		if (! is_master (self_nodeid)) 
			CommitChanges(slave_refer_to_lines_x(self_nodeid), 512);
		else
			CommitChanges ((void *) MASTER_NTIME, 34404);
		goto calc_start;
	}

	if (!is_master(self_nodeid))
		sleep (1);
	else {
		(*ntime)++;
		ClearNodes ();
	}
}

void
ClearCanvas ()
{
	for (int i = 0; i < 200; i++)
		memset ((fbptr+(80+i)*640), 0, sizeof (short) * 320);

	return ;
}

int main(int argc, char *argv[])
{
	int fd_framebuffer;
	struct fb_fix_screeninfo finfo;
	struct fb_var_screeninfo vinfo;

		/* 読み書き用にファイルを開く */
	fd_framebuffer = open( DEVICE_NAME , O_RDWR);
	if ( !fd_framebuffer ) {
		exit(1);
	}
	/* 固定スクリーン情報取得 */
	if ( ioctl( fd_framebuffer , FBIOGET_FSCREENINFO , &finfo ) ) {
		exit(2);
	}
	if ( ioctl( fd_framebuffer , FBIOGET_VSCREENINFO , &vinfo ) ) {
		exit (3);
	}

	if (! (xMax = vinfo.xres) || ! (yMax = vinfo.yres)) {
		fprintf (stderr, "Counld get the screen resolution\n");
		exit (4);
	}
	fbptr = (unsigned short *)finfo.smem_start;
	if (! is_master(self_nodeid))
		sleep (1);
	else {
		CommitChanges ((void *) MASTER_NTIME, 34404);
	}

	while (1) {
		ray_main ();
//		ClearCanvas ();
	}

	return 0;
}

// 点を描画する関数
void DrawPixel(int x,int y, unsigned int R, unsigned int G, unsigned int B)
{
	unsigned int col;
	col = ((R << 8) & 0xf800) | ((G << 3 ) & 0x7e0 ) | ((B >> 3));
	*(fbptr+(y+80)*xMax + x) = col;
}
